#ifdef I_STDTYPES
#include <sys/stdtypes.h>
#endif
#ifdef I_STDDEF
#include <stddef.h>
#endif
#ifdef I_SYSTYPES
#include <sys/types.h>
#endif

#ifndef VOIDSTAR
#define VOIDSTAR void *
#endif

#ifndef __STDC__
#define const	/* Nothing */
#endif

/* Until ANSI becomes commenplace, we'll have to prototype all the standard
routines ourselves. . . */

/* Declarations for system functions, etc
   These shouldn't be needed, but are */

#define REVERSE

extern int errno;

extern void exit EXT1(int);

extern char *getenv EXT1(const char *);

extern void free EXT1(void *);

extern void bcopy EXT3(const void *, void *, size_t);
extern int bcmp EXT3(const void *,const void *,size_t);
extern void bzero EXT2(void *,size_t);

extern size_t strlen EXT1(const char *);
extern int strncmp EXT3(const char *,const char *,size_t);
extern int strcmp EXT2(const char *,const char *);
extern int stricmp EXT2(const char *,const char *);
extern int strincmp EXT3(const char *,const char *,size_t);
extern char *strcpy EXT2(char *,const char *);
extern char *strncpy EXT3(const char *,const char *,int);
extern char *strcat EXT2(char *,const char *);

extern const char *strstr EXT2(const char *,const char *);

extern int atoi EXT1(const char *);

extern double pow EXT2(double, double);
extern double astof EXT1(char **);
extern double fabs EXT1(double);
extern double log EXT1(double);

extern double ceil EXT1(double);
extern double floor EXT1(double);
extern double sqrt EXT1(double);

extern double modf EXT2(double, double *);

extern char *ctime EXT1(long *);
extern int write EXT3(int, const void *, int);

extern long time EXT1(long *);
extern long random EXT0();

extern int vsprintf EXT3(char *,const char *,va_list);

#ifndef __TURBOC__
#if !defined(vax) && !defined(hp300) && !defined(mips) && !defined(sun)
/* Sigh. */
extern int sprintf EXT2N(char *,const char *);
#else
/* We've been screwed by stdio.h */
/* extern char *sprintf EXT2N(char *,const char *); */
#endif
#endif

#if defined(SYSV) || defined(__TURBOC__)
#define rindex strrchr
#define index  strchr
#endif

extern const char *index EXT2(const char *,char);
extern char *rindex EXT2(const char *,char);

#ifdef stdin
extern int vfprintf EXT3(FILE *,const char *,va_list);
extern int fputs EXT2(const char *, FILE *);
extern int fflush EXT1(FILE *);
#endif

#ifndef __TURBOC__
extern unsigned ualarm();

#ifdef stdin
extern int printf EXT1N(const char *);
extern int fflush EXT1(FILE *);
extern int fprintf EXT2N(FILE *,const char *);
extern int _filbuf();
extern int _flsbuf();
extern int fclose EXT1(FILE *);
#endif
extern void pause EXT0();
extern void sleep EXT1(unsigned);
extern int read EXT3(int, char *, size_t);
extern int fcntl EXT2N(int, int);
#endif

#ifndef SYSV
#ifdef stdin
#ifndef AMIGA
extern void setbuffer EXT3(FILE *,char *,size_t);
#endif
#endif
extern int access EXT2(const char *, int);
#endif

#if defined(__STDC__) && defined(obstack_chunk_alloc)
extern void _obstack_begin EXT5(struct obstack *, int, int, void *(*) (), void (*) ());
extern void _obstack_newchunk EXT2(struct obstack *, int);
extern void _obstack_free EXT2(struct obstack *, void *);
#endif

#ifdef USE_DLD
extern int dld_errno;
extern int dld_nerr;
extern char *dld_errlst[];
extern dld_undefined_sym_count;
extern char *dld_search_path;

extern void (*dld_get_func())();
extern int dld_unlink_by_file EXT2(char *,int);
extern int dld_link EXT1(char *);
extern int dld_function_executable_p EXT1(char *);
extern int dld_init EXT1(char *);
extern char *dld_find_executable EXT1(char *);
extern char ** dld_list_undefined_sym EXT0();
#endif
